/*
=================================================================== 

		Random House Patrol Script v0.9
		    by Tophe of stgta Ops

===================================================================

This script is based on my earlier Random Building Position Script.

There is a bug in ArmA that sometimes keeps a unit from
reporting that it has finished or failed a move command.
This script contains a workaround to that bug, but as soon 
as BIS has fixed this bug I will release version 1.0

Contact & bugreport: harlechin@hotmail.com

====================================================================

HOW TO USE:

* In Multiplayer put an empty game logic named "server" on the map.

* Put this: guard = [this] execVM "HousePatrol.sqf" 
  in the init field of a unit and put it next to or on a house.



OPTIONAL SETTINGS:

* You may also set the behaviour of the unit by putting the 
  prefered behaviour in the array.

  Like this: guard = [this,"COMBAT"] execVM "HousePatrol.sqf" 
  You may put any of these five:

    * "CARELESS"
    * "SAFE"
    * "AWARE"
    * "COMBAT"
    * "STEALTH". 

  If you don't put anything the default "SAFE" will be set.


====================================================================
*/

if !(local server) exitWith {};
sleep 0.5;

// Setting variables

	_unit = _this select 0;
	_beh = _this select 1;
	_house = nearestbuilding (_this select 0);
	_x = 0;
	_y = 0;
	_t = 0;
	_timeout = 0;


// Set the behaviour of the unit
	
 if (isnil ("_beh")) then {_beh="SAFE"}; 

     if (_beh == "CARELESS" 
	or _beh == "SAFE" 
	or _beh == "AWARE" 
	or _beh == "COMBAT" 
	or _beh == "STEALTH") 
	then {_unit setbehaviour _beh} 
	else {_unit setbehaviour "SAFE"};



// Find out the number of positions available in the building
// and put the unit at a random starting position

	while { format ["%1", _house buildingPos _x] != "[0,0,0]" } do {_x = _x + 1};
	_x = _x - 1;
	_unit setPos (_house buildingpos (random _x)); 



// Have the unit patrol inside the house

	while {alive _unit} do
	{
		_y = random _x;
		_t = random (25)+5;
		_unit doMove (_house buildingpos _y);
		sleep 0.5;
		_timeout = time + 90;
		waitUntil {moveToCompleted _unit or moveToFailed _unit or !alive _unit or _timeout < time};
		sleep _t;

	};

// Now he's dead, so lets get out of this script!

exit;